#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do
{
	defautoseq base64enc intconv:FromInt|base64enc|intconv:ToDec
	global keepit;
}

openflow(id param dir name)
{
	global val_$id cnt_$id ll_$id = 0;
	defautoseq dec_$id base64enc:Decode;
}

closeflow(id)
{
	if neq(int 0 var(cnt_$id))
		set val_$id = bitshift(var(val_$id) mul(8 sub(3 var(cnt_$id))) )
		return(encode($id))
	endif
	remove GLOBALS val_$id
	remove GLOBALS cnt_$id
	remove GLOBALS ll_$id
	rmautoseq dec_$id
}

getc(id ch)
{
	def out;
	if not(var(val_$id))
		if neq($ch eof)
			set val_$id = var(val_$id)itranslate(dec_$id $ch)
		endif
	endif
	set val_$id = split(var(val_$id) ' ' '' out);
	set keepit = var(val_$id)
	if $out
		return(cond(eq(int $out 0) null char($out)))
	else
		return(cond(or(eq($ch eof) isfinal(dec_$id)) eof))
	endif
}

encode(id)
{
	def val = bitor(var(val_$id) bitshift(var(cnt_$id) 24));
	def out = translatez(base64enc $val);
	clear cnt_$id
	clear val_$id
	incr ll_$id 4
	if eq(int var(ll_$id) 76)
		set out = $out\ ascii(\n)
		clear ll_$id
	endif
	return($out)
}


putc(id ch)
{
	set val_$id = add(ascii($ch) bitshift(var(val_$id) 8))
	incr cnt_$id 1
	if eq(int var(cnt_$id) 3)
		return(encode($id))
	endif
}

puts(id str)
{
	def out;
	while $str
		set out = $(out)putc($id substr($str 0 1))
		set str = substr($str 1)
	loop
	return($out)
}
