#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	table identity get(ARGV 1)
	def iter;
	defstream outstream '' html true
	outstream outstream
	foreach iter identity
		switch $iter
			when eq($^ id)
			when eq($^ email)
			when eq($^ mbox)
			when eq($^ passcode)
				writetag identity $iter get(identity $iter) /;
				write \n;
				breaksw
			when eq($^ news)
				writetag news dir get(identity $iter) /;
				write \n;
				breaksw
			when eq($^ hotnews)
				writetag news hot get(identity $iter) /;
				write \n;
				breaksw
			when eq($^ newscharset)
				writetag news charset get(identity $iter) /;
				write \n;
				breaksw
			when eq($^ newsext)
				writetag news ext get(identity $iter) /;
				write \n;
				breaksw
			when eq($^ newsmax)
				writetag news max get(identity $iter) /;
				write \n
				breaksw
			when eq($^ lastlen)
				breaksw
			when eq($^ newsmode)
				writetag news mode get(identity $iter) /;
				write \n
				breaksw
			when isprefix($^ news)
				writetag news block substr($iter 4);
				ioctl outstream raw
				write get(identity $iter)
				ioctl outstream cooked
				writetag /news;
				write \n;
				breaksw
			when true
				writetag mime type $iter dir get(identity $iter) /;
				write \n;
		endsw
	loop
}
