#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do { defautoseq readline linefilter }

streamopen(name param writable)
{
	defstream "lf_$name" $param basic;
}

streamclose(name)
{
	release stream "lf_$name"
}

read(name)
{
	def in;
	cleartag	
	set in = readfrom("lf_$name" reset(readline))
	if iseof() return endif
	settag '' 'LINE'
	settag 'value' $in
}

getpos(name)
{
	return(getpos(lf_$name))	
}

setpos(name pos)
{
	setpos lf_$name $pos
}

rewind(name)
{
	rewind lf_$name
}

ioctl(name ctlstr)
{
	return(ioctl(lf_$name $ctlstr))
}
