#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	if getenv(GATEWAY_INTERFACE)
		defstream ins getenv(PATH_TRANSLATED) html;
		write 'Content-Type: text/html'
		write ''
	else
		defstream ins '' html;
		defstream outs '' html writable;
		outstream outs
	endif
	ioctl ins keepspaces
	instream ins
	global script_counter = 0
		   object_counter = 0
		   cgiimg_counter = 0
	
}

tag "SCRIPT"
{
	incr script_counter 1
	prefix 'in-script:'
}

tag "in-script:/SCRIPT" { prefix '' }

tag "in-script:*" {}
char "in-script:?" {}


tag "OBJECT" { incr object_counter 1 }
tag "/OBJECT" { return }

tag "EMBED" { incr object_counter 1 }
tag "/EMBED" { return }

tag "IMG"
{
	if index(tag(SRC) cgi)
		incr cgiimg_counter 1
		settag SRC safeimage.gif
	endif
	writetag
}

tag "/BODY"
{
	if neq(int 0 add($object_counter $script_counter $cgiimg_counter))
		writetag HR;
		write "Potentially unsafe elements discarded:\n";
		writetag UL;
		writetag LI;
		write "Scripts - $script_counter\n";
		writetag /LI;
		writetag LI;
		write "Objects - $object_counter\n";
		writetag /LI;
		writetag LI;
		write "CGI images - $cgiimg_counter\n";
		writetag /LI;
		writetag /UL;
	endif
	writetag
}

tag "*" { writetag }
char "*" { writetag }

