#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

set.add(set1 set2)
{
	def iter;
	foreach iter $set2
		if not(check($set1 $iter))
			insert $set1 $iter get($set2 $iter)
		endif
	loop
	return($set1)
}

set.subtract(set1 set2)
{
	def iter;
	foreach iter $set2
		if check($set1 $iter)
			remove $set1 $iter
		endif
	loop
	return($set1)
}

set.intersect(set1 set2)
{
	def iter;
	foreach iter $set1
		if not(check($set2 $iter))
			mark-remove($set1 $iter)
		endif
	loop
	do-remove($set1)
	return($set1)
}

set.includes(set1 set2)
{
	def iter;
	foreach iter $set1
		if not(check($set2 $iter))
			return
		endif
	loop
	return(true)
}

set.overlaps(set1 set2)
{
	def iter;
	foreach iter $set1
		if check($set2 $iter)
			return(true)
		endif
	loop
}
