#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	read
	check-required('email 'get(ARGV 2))
	defstream mailer "pipe:///usr/sbin/sendmail get(ARGV 1)" basic true
	outstream mailer
	write "To: get(ARGV 1)\n"
	write "From: trim(tag(email))\n"
	write "Subject: subscribe\n"
	write \n
	def all = $[*] arg val;
	while $all
		set all = split($all '\t' '\n' arg val)
		write "$arg\: $val\n"
	loop
	outstream stdout
	write "Location: get(ARGV 3)"
	write \n
	exit
}

check-required(fields)
{
	def fld fld1 fld2;
	set fields = trim($fields)
	while $fields
		set fields = span(split($fields ' ' '' fld) ' ')
		if index($fld ?)
			split($fld ? '' fld1 fld2)
			if isprefix($fld1 !)
				set fld = cond(not(tag(substr($fld1 1))) $fld2)
			else
				set fld = cond(tag($fld1) $fld2)
			endif
		endif
		if $fld
			if not(tag($fld))
					writeto stdout "Location: get(ARGV 4)"
					writeto stdout ''
					exit
				endif
		endif
	loop
}
