#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.include "bstream"

read(name)
{
	cleartag
	def ch  = readfrom($name)
		ch1 = readfrom($name);
	if iseof() return endif
	settag '' '&';
	settag value add(mul(ascii($ch1) 256) ascii($ch))
}

writestr(name str)
{
	while $str
		writeto $name substr($str 0 1)
		writetagto $name NULL;
		set str = substr($str 1)
	loop
}

writetag(name)
{
	if eq($[] '&')
		def hi = div($[value] 256)
			lo = rem($[value] 256);
		if eq(int 0 $lo)
			writetagto $name NULL;
		else
			writeto $name char($lo)
		endif
		if eq(int 0 $hi)
			writetagto $name NULL;
		else
			writeto $name char($hi)
		endif
	endif
}
