#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	table words !words;
	global inword = "";
	global wordbuf;
	defautoseq(classify koi8r:Classify);
	defautoseq(tolower koi8r:Tolower);
}

put-word
{
	def val;
	if index($val '-') echo $val endif
	if check(words $1)
		set val = get(words $1)
		incr val 1;
		put words $1 int($val);
	else
		insert words $1 int(1);
	endif
}
char "hyphen:[\n\r\f]" { prefix "" }
char "hyphen:[ \t\v]" {}
char "hyphen:*" { 
					set wordbuf = $(wordbuf)'-'
					prefix ""; 
					dispatch 
				}

char "-" { if $inword prefix "hyphen:" endif }

char "*" { reset(classify); translate classify $[value]; 
		   #echo "$[value]: state(classify)"
		   switch state(classify)
				case mapstate(classify "Isalpha")
					set inword = true
					set wordbuf = $(wordbuf)translate(tolower $[value])
					breaksw
				case *
					if and($inword $wordbuf)
						set inword = ""
						#echo $wordbuf
						put-word($wordbuf)
						set wordbuf = ""
					endif
		   endsw
		 }
